  MEMBER

  MAP
  END

  INCLUDE('ABUTIL.INC'),ONCE
  INCLUDE('PDABUTIL.INC'),ONCE
  INCLUDE('KEYCODES.CLW'),ONCE

PDCalendarBaseClass.Ask PROCEDURE(STRING pTitle,LONG pDate=0)
!-- This is a copy of the CalendarBaseClass.Ask with modifications as noted.
!--    Added Window aas a parameter.
!--    Added Translate method call.
WindowInitialized    BYTE
DayStr               STRING(3)
CurrTime             LONG
MonthYear            STRING(15)
The_date             LONG
the_last_date        LONG
the_month            SHORT
the_day              SHORT
the_year             SHORT
base_col             SHORT
last_day             SHORT
base_date            LONG
cur_mo               LONG
cur_yr               LONG
mo_and_yr            LONG
start_date           LONG
sunday_date          LONG
butnum               SHORT
FirstButNum          SHORT
daynum               SHORT
 INCLUDE('ABUTILUI.INC', 'CalendarDayGroup')
SatCol               BYTE
SunCol               BYTE
Day_array            STRING(3),DIM(7),OVER(day_group)
 INCLUDE('ABUTILUI.INC', 'CalendarMonthGroup')
month_array          STRING(10),DIM(12),OVER(month_group)
loc:fecha            LONG
lHIni                LONG
lHEnd                LONG
  CODE
  PUSHBIND

  IF SELF.CtrlCurrTime THEN
     SELF.CtrlCurrTime{PROP:USE}=CurrTime
  END
  IF SELF.CtrlMonthYear THEN
     SELF.CtrlMonthYear{PROP:USE}=MonthYear
  END
  IF SELF.CtrlTheDate THEN
     SELF.CtrlTheDate{PROP:USE}=The_Date
  END
  SELF.FirstWeekDay = 7
  SELF.SetUp()
  IF NOT(SELF.FirstWeekDay>=1 AND SELF.FirstWeekDay<=7) THEN
     SELF.FirstWeekDay = 7
  END
  Do DoReorderDays
  FirstButNum = SELF.CtrlDay1 + (7-SELF.FirstWeekDay)
  SELF.SelectedDate=0
  SELF.Response = RequestCancelled
  IF pDate=0 THEN
     start_date =  TODAY()
  ELSE
     start_date = pDate
  END
  IF ~INRANGE(start_date,DATE(1,1,1801),DATE(12,31,2099))
     start_date = Today()
  END
  the_date = start_date
  mo_and_yr = 0
  cur_mo    = 0
  cur_yr    = 0
  sunday_date = DATE(1,3,1993) ! A known Sunday
  loc:fecha = the_date
  the_last_date= the_date
  IF KEYCODE() = MouseRight
    SETKEYCODE(0)
  END
  IF SELF.XPos THEN
     IF SELF.RightAlignment THEN
        0{PROP:XPOS}=SELF.XPos-0{PROP:Width}
     ELSE
        0{PROP:XPOS}=SELF.XPos
     END
  END
  IF SELF.YPos THEN
     0{PROP:YPOS}=SELF.YPos
  END
  IF CLIP(pTitle) THEN                                               !-- Move to before translation
     0{prop:text}=pTitle
  ELSE
     0{prop:text}=''
  END
  SELF.Translate(Month_Array,Day_Array)                              !-- Added call to translation.
  DO PrepareProcedure
  lHIni=0{PROP:HEIGHT}
!  IF CLIP(pTitle) THEN
!     0{prop:text}=pTitle
!  ELSE
!     0{prop:text}=''
!  END
  DISPLAY()
  lHEnd=0{PROP:HEIGHT}
  IF lHIni<>lHEnd THEN
     0{PROP:HEIGHT}=0{PROP:HEIGHT}+(lHIni-lHEnd)
  END
  SELF.Response = RequestCancelled
  ACCEPT
    CASE EVENT()
    OF EVENT:AlertKey
       CASE KEYCODE()
         OF UpKey
               Do PrevWeek
               SELECT(SELF.CtrlExit)
         OF DownKey
               Do NextWeek
               SELECT(SELF.CtrlExit)
         OF LeftKey
               Do PrevDay
               SELECT(SELF.CtrlExit)
         OF RightKey
               Do NextDay
               SELECT(SELF.CtrlExit)
         OF EnterKey
                 IF FOCUS()<> SELF.CtrlExit
                    PRESSKEY(TabKey)
                    CYCLE
                 ELSE
                    ! Select the OK button
                    POST(Event:Accepted,SELF.CtrlExit)
                    CYCLE
                 END!IF
       END!CASE
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
         DISPLAY()
         WindowInitialized = True
      END
      SELECT(SELF.CtrlExit)
    OF EVENT:GainFocus
      IF NOT WindowInitialized
         WindowInitialized = True
      END
      DISPLAY()
    OF EVENT:Timer
      Do ShowTime
    OF Event:Rejected
      BEEP
      DISPLAY(?)
      SELECT(?)
    END
    IF FIELD()>0 THEN
       CASE FIELD()
       OF SELF.CtrlDay1 TO SELF.CtrlDay42
         CASE EVENT()
         OF EVENT:Accepted
         ! Set numeric date:
         !   Month and year are known
         !   Day is current button minus button for first day of month
         !     minus the first day of month plus one
         the_date = DATE(the_month,?-SELF.CtrlDay1-base_col+1,the_year)
         DO DoSelect
         DO DoUpdateScreen
         the_last_date= the_date
         SELF.Response = RequestCompleted
         POST(Event:Accepted,SELF.CtrlExit)
         CYCLE
         OF EVENT:Selected
         the_date = DATE(the_month,?-SELF.CtrlDay1-base_col+1,the_year)
         DO DoSelect
         DO DoUpdateScreen
         the_last_date= the_date
         END
       OF SELF.CtrlToday
          CASE EVENT()
          OF EVENT:Accepted
             DO DoToday
             DO DoSelect
             DO DoUpdateScreen
          END
       OF SELF.CtrlPrevMonth
         CASE EVENT()
         OF EVENT:Accepted
           Do DoPrevMonth
         END
       OF SELF.CtrlNextMonth
         CASE EVENT()
         OF EVENT:Accepted
           Do DoNextMonth
         END
       OF SELF.CtrlPrevYear
         CASE EVENT()
         OF EVENT:Accepted
           Do DoPrevYear
         END
       OF SELF.CtrlNextYear
         CASE EVENT()
         OF EVENT:Accepted
           Do DoNextYear
         END
       OF SELF.CtrlLess7
         CASE EVENT()
         OF EVENT:Accepted
           Do PrevWeek
         END
       OF SELF.CtrlMore7
         CASE EVENT()
         OF EVENT:Accepted
           Do NextWeek
         END
       OF SELF.CtrlLess15
         CASE EVENT()
         OF EVENT:Accepted
           Do Prev2Week
         END
       OF SELF.CtrlMore15
         CASE EVENT()
         OF EVENT:Accepted
           Do Next2Week
         END
       OF SELF.CtrlExit
         CASE EVENT()
         OF EVENT:Accepted
            IF SELF.SelectOnClose THEN
               SELF.Response = RequestCompleted
            END
            POST(Event:CloseWindow)
         END
       END
    END
  END
  IF SELF.Response = RequestCancelled THEN
     loc:fecha = start_date
  END
  SELF.SelectedDate = loc:fecha
  SELF.XPos=0
  SELF.YPos=0
  POPBIND
  RETURN(loc:fecha)
!---------------------------------------------------------------------------
PrepareProcedure ROUTINE
  ALERT(EnterKey)
  ALERT(DownKey)
  ALERT(RightKey)
  ALERT(UpKey)
  ALERT(LeftKey)
  DO ShowTime
  DO DoUpdateScreen
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
!---------------------------------------------------------------------------
DoReorderDays   ROUTINE
  base_col=SELF.FirstWeekDay
  LOOP butnum=0 TO 6
     (SELF.CtrlSun+butnum){PROP:TEXT}=Day_array[base_col]
     IF base_col=6 THEN SatCol=butnum+1.
     IF base_col=7 THEN SunCol=butnum+1.
     base_col+=1
     IF base_col>7 THEN base_col=1.
  END

DoUpdateScreen          ROUTINE
  the_month = MONTH(the_date)
  the_day = DAY(the_date)
  the_year = YEAR(the_date)
  ! Need to show new month?
  IF (cur_mo=the_month AND cur_yr=the_year) THEN
     IF the_last_date= the_date THEN EXIT.
     daynum=DAY(the_last_date)
     butnum=daynum-1+base_col+SELF.CtrlDay1
        butnum{PROP:TEXT}=clip(FORMAT(daynum,@P##P))
          butnum{PROP:FontStyle}=FONT:regular
       daynum=DAY(the_date)
       butnum=daynum-1+base_col+SELF.CtrlDay1
       butnum{PROP:FontStyle}=FONT:bold+FONT:underline !today's date
     EXIT
  END
  MonthYear = CLIP(month_array[the_month]) & ' ' & the_year
  base_date = DATE(the_month, 1, the_year)
  base_col = ABS((base_date - (sunday_date-(7-SELF.FirstWeekDay) )) % 7)  ! Column for first day
  last_day = DAY(DATE(the_month + 1, 1, the_year) -1) ! Last day of month
  LOOP butnum = SELF.CtrlDay1 TO SELF.CtrlDay42 ! Label buttons
    daynum = butnum - SELF.CtrlDay1 - base_col + 1
    DO DayToStr
    IF LEN(CLIP(daystr)) > 0
      UNHIDE(butnum)
      butnum{PROP:TEXT}=clip(FORMAT(daynum,@P##P))
      IF butnum=SELF.CtrlDay1+(SunCol-1) or butnum=SELF.CtrlDay1+7+(SunCol-1) or butnum=SELF.CtrlDay1+14+(SunCol-1) or butnum=SELF.CtrlDay1+21+(SunCol-1) or butnum=SELF.CtrlDay1+28+(SunCol-1) or butnum=SELF.CtrlDay1+35+(SunCol-1) THEN
        butnum{PROP:FontColor}=SELF.ColorSunday
        butnum{PROP:FontStyle}=FONT:regular
      ELSE
        IF butnum=SELF.CtrlDay1+(SatCol-1) or butnum=SELF.CtrlDay1+7+(SatCol-1) or butnum=SELF.CtrlDay1+14+(SatCol-1) or butnum=SELF.CtrlDay1+21+(SatCol-1) or butnum=SELF.CtrlDay1+28+(SatCol-1) or butnum=SELF.CtrlDay1+35+(SatCol-1) THEN
          butnum{PROP:FontColor}=SELF.ColorSaturday
          butnum{PROP:FontStyle}=FONT:regular
        ELSE
          butnum{PROP:FontColor}=SELF.ColorOther
          butnum{PROP:FontStyle}=FONT:regular
        END
      END
      IF SELF.IsHoliday(daystr,the_month,the_year,daynum) THEN
         butnum{PROP:FontColor}=SELF.ColorHoliday
         butnum{PROP:FontStyle}=FONT:regular
      END
      IF DATE(the_month, daystr, the_year) = the_date
        butnum{PROP:FontStyle}=FONT:bold+FONT:underline !today's date
      END
     ELSE
      HIDE(butnum)
    END
  END
  cur_mo = the_month
  cur_yr = the_year
  mo_and_yr = the_month + the_year ! Currently showing this month/year
!---------------------------------------------------------------------------
! Show the current time
ShowTime        ROUTINE
  CurrTime = CLOCK()
!---------------------------------------------------------------------------
NextDay         ROUTINE
  the_date = the_date + 1
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
PrevDay         ROUTINE
  the_date = the_date - 1
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
PrevWeek        ROUTINE
  the_date = the_date - 7
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
NextWeek        ROUTINE
  the_date = the_date + 7
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
Prev2Week        ROUTINE
  the_date = the_date - 15
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
Next2Week        ROUTINE
  the_date = the_date + 15
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
! Show next month
DoNextMonth     ROUTINE
  the_month += 1
  DO FixupMonth
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
! Show last month
DoPrevMonth     ROUTINE
  the_month -= 1
  DO FixupMonth
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
! Show same month, next year
DoNextYear      ROUTINE
  the_year += 1
  DO FixupMonth
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
! Show same month, last year
DoPrevYear      ROUTINE
  the_year -= 1
  DO FixupMonth
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
! Pressed a button to select a date
DoSelect        ROUTINE
  IF the_date > 0
    loc:fecha = the_date
  END
!---------------------------------------------------------------------------
! Show current month/year
DoToday         ROUTINE
  the_date = Today()
  DO DoSelect
  Do DoUpdateScreen
  the_last_date= the_date
!---------------------------------------------------------------------------
! Fix month number up
FixupMonth      ROUTINE
  IF the_month < 1
     the_year -= 1
     the_month = 12
  ELSIF the_month > 12
     the_year += 1
     the_month = 1
  END
  the_date = DATE(the_month, the_day, the_year)
  IF MONTH(the_date)<>the_month
     the_date = DATE(the_month, 1, the_year)
  END
  the_last_date= the_date
!---------------------------------------------------------------------------
! Exit calendar
DayToStr        ROUTINE
  IF daynum > last_day THEN daynum = 0. ! Blank button
  IF daynum <= 0
    daystr = ''
  ELSE
    daystr = FORMAT(daynum,@n2)
  END

!-------------------------------------
PDCalendarBaseClass.AddItem PROCEDURE(TranslatorClass pTranslator)
  CODE
  SELF.Translator &= pTranslator
!-------------------------------------
PDCalendarBaseClass.Translate PROCEDURE(*STRING[] pMonthArray,*STRING[] pDayArray)
  CODE
  IF ~SELF.Translator &= NULL
    !-- Translate Month
    LOOP I#=1 TO 12
      pMonthArray[I#]=SELF.Translator.TranslateString(CLIP(pMonthArray[I#]))  !-- Note CLIP is needed here.
    END
    !-- Translate Day
    LOOP I#=1 TO 7
      pDayArray[I#]=SELF.Translator.TranslateString(CLIP(pDayArray[I#]))
    END
    !-- Translate buttons etc.
    SELF.Translator.TranslateWindow()
  END
!-------------------------------------
PDCalendarClass.Ask                   PROCEDURE(STRING pTitle,LONG pDate=0)
 INCLUDE('ABUTILUI.INC', 'CalendarClassWindow')
 CODE
   OPEN(Screen)
   SELF.CtrlSun       = ?Sun
   SELF.CtrlExit      = ?Exit
   SELF.CtrlToday     = ?Today
   SELF.CtrlDay1      = ?Day1
   SELF.CtrlDay42     = ?Day42
   SELF.CtrlPrevMonth = ?PrevMonth
   SELF.CtrlNextMonth = ?NextMonth
   SELF.CtrlPrevYear  = ?PrevYear
   SELF.CtrlNextYear  = ?NextYear
   SELF.CtrlMore7     = ?More7
   SELF.CtrlLess7     = ?Less7
   SELF.CtrlMore15    = 0
   SELF.CtrlLess15    = 0
   SELF.CtrlCurrTime  = 0
   SELF.CtrlMonthYear = ?MonthYear
   SELF.CtrlTheDate   = 0
   SELF.CtrlTitleBG   = ?BoxTitleBackground
   SELF.CtrlBodyBG    = ?BoxBodyBackground
   RETURN PARENT.Ask(pTitle,pDate)

!!-------------------------------------
PDCalendarSmallClass.Ask                   PROCEDURE(STRING pTitle,LONG pDate=0)
 INCLUDE('ABUTILUI.INC', 'CalendarSmallClassWindow')
 CODE
   OPEN(Screen)
   SELF.CtrlSun         = ?Sun
   SELF.CtrlExit        = ?Exit
   SELF.CtrlToday       = ?Today
   SELF.CtrlDay1        = ?Day1
   SELF.CtrlDay42       = ?Day42
   SELF.CtrlPrevMonth   = ?PrevMonth
   SELF.CtrlNextMonth   = ?NextMonth
   SELF.CtrlPrevYear    = ?PrevYear
   SELF.CtrlNextYear    = ?NextYear
   SELF.CtrlMore7       = ?More7
   SELF.CtrlLess7       = ?Less7
   SELF.CtrlMore15      = ?More15
   SELF.CtrlLess15      = ?Less15
   SELF.CtrlCurrTime    = ?CurrTime
   SELF.CtrlMonthYear   = ?MonthYear
   SELF.CtrlTheDate     = ?TheDate
   SELF.CtrlTitleBG     = 0
   SELF.CtrlBodyBG      = ?BoxBodyBackground
   RETURN PARENT.Ask(pTitle,pDate)
